// ***********************************************************************
//                Microchip FAE Training        Exercise 5
//
// Purpose : mߦpϥ QEI ҲժӿJ QEA & QEB pXt
//           ñNtH 300mS ɶܩ LCD W
//
// ***********************************************************************

#include 	<p30fxxxx.h>
#include 	<timer.h>
#include	<qei.h>					
#include 	"C30EVM_LCD.h"			// NLCD禡쫬ŧiɮקtJ 

#define		FCY 	7372800 * 2		// ]ϥWvN~ 7.3728 MHz * 8 Ҧ , C@Og 4  clock
									// ҥH FCY =  (7.3728 * 8 / 4 ) MHz = 7372800* 2

//---------------------------------------------------------------------------
// аѦҦB Configuration bits {ŧi覡
// ԲӪѼƦCаѦ p30F4011.h 
//---------------------------------------------------------------------------
   	_FOSC(CSW_FSCM_OFF & XT_PLL8);   //	XT with 8xPLL oscillator, Failsafe clock off
   	_FWDT(WDT_OFF);                  //	Watchdog timer disabled
  	_FBORPOR(PBOR_OFF & MCLR_EN);    //	Brown-out reset disabled, MCLR reset enabled
   	_FGS(CODE_PROT_OFF);             //	Code protect disabled

const char	My_String1[]="RPM Measurement" ;	// ŧir Program Memory
const char	My_String2[]=" RPM :         " ;	// ŧir Data Memory

void	Init_Timer1(void) ;
void	Init_QEI (void) ;
void	uitoa( unsigned char * , unsigned int ) ;

unsigned char	Minute = 0 ;
unsigned char	Second = 0 ;
unsigned char	TimeBase = 0 ;
unsigned int	QEI_Old = 0 ;
unsigned int	QEI_New = 0 ;
unsigned int	QEI_Diff ;
unsigned int	RPM ;
unsigned int	LCD_Update_Count=3;  			// 300mS update on LCD

unsigned char	Convert_Buf[10] ;

union 	{
			unsigned char ByteAccess ;
			struct 	{
						unsigned Bit0: 1 ;
						unsigned Bit1: 1 ;
						unsigned Bit2: 1 ;
						unsigned unused : 5 ;
					} ;
		} SystemFlag ;

#define	OneSecond	SystemFlag.Bit0 
#define	QEI_Update 	SystemFlag.Bit2

void _ISR _T1Interrupt(void)
{
	TimeBase += 1 ;

	QEI_New = ReadQEI( ) ;
	QEI_Update = 1 ;

	if (TimeBase >= 10)				// Time is over 1 Second?
		{
			OneSecond = 1 ;
			TimeBase  = 0 ;
		} 

	if (LCD_Update_Count!=0) LCD_Update_Count--;

	IFS0bits.T1IF = 0 ;

}

int	main( void )
{

	OpenLCD( ) ;											// ϥ OpenLCD( ) LCD Ҳէ@lƳ]w
															// 4 bits Data mode
															// 5 * 7 Character 
	ADPCFG = 0xffff ;										// AN3 , AN4 , AN5 as difital for QEI !!

	QEI_Old = 0 ;
	QEI_New = 0 ;
	Init_QEI( ) ;
	Init_Timer1( );


		setcurLCD(0,0) ;									// ϥ setcurLCD( ) ]wЩ (0,0)
		putrsLCD( My_String1 ) ;							// Nsb Program Memory rϥ
															// putrsLCD( ) LX LCD
			
		setcurLCD(0,1) ;
		putrsLCD( My_String2 ) ;							// ϥ setcurLCD( ) ]wЩ (0,1)
															// Nsb Data Memory rϥ	
															// putsLCD( ) LX LCD
		OneSecond = 0 ;

		while(1) 
		{	
 			if ( QEI_Update )								// RPM calclation every 100mS
			{
				QEI_Update = 0 ;

				setcurLCD(8,1) ;

				if ( QEICONbits.UPDN )		putcLCD('+') ;		// ھUPDN줸Mw઺V
				else						putcLCD('-') ;
					
				
				if ( QEICONbits.UPDN )							// Fɪp
				{
					if ( QEI_New >= QEI_Old )					// pɶƶq
						QEI_Diff = QEI_New - QEI_Old ;
					else										// ɪBz
						QEI_Diff = QEI_New + ( 65536 - QEI_Old ) ;	
				}
				else											// Fɪp
				{
					if (QEI_New < QEI_Old )
						QEI_Diff = QEI_Old - QEI_New ;
					else
						QEI_Diff = ( 65536 - QEI_New )+ QEI_Old ; // ɦɪBz
				}
				
				QEI_Old = QEI_New ;					// sQEIƭ
				
				RPM = ((long)QEI_Diff*600/256);		// tp (100mS * 600= 1 Minute, Index=64 4 = 256)


				if (LCD_Update_Count==0)
				{
					uitoa ( Convert_Buf , RPM ) ;		// ഫQiAন ASCII Code

					setcurLCD(10,1) ;					// tb LCD 
					putrsLCD( "     " ) ;

					setcurLCD(10,1) ;
					putsLCD( Convert_Buf ) ;

					LCD_Update_Count=3;					// Set LCD update time for 300mS
				}

			}
	
		}		
}

/*************************************************/
// Timer1 ҲժlưƵ{
// 100mS Interrupt setting
/*************************************************/
void Init_Timer1(void)
{
		ConfigIntTimer1( T1_INT_PRIOR_7 & T1_INT_ON ) ;		// Timer1 _uų] 7 (̰)
															// Timer1 _ ON 

		OpenTimer1( T1_ON & T1_IDLE_STOP & T1_GATE_OFF & 	// Timer1  Period ]C 100 ms 
					T1_PS_1_64 & T1_SYNC_EXT_OFF & T1_SOURCE_INT ,
						(long)((FCY/ 1000)* 100 )/64 ) ;
}
/*************************************************/
// QEIҲժlưƵ{
//
/*************************************************/
void Init_QEI(void)
{
	
	ConfigIntQEI(QEI_INT_DISABLE&QEI_INT_PRI_0) ;

	OpenQEI( 	QEI_MODE_x4_MATCH & QEI_IDLE_CON &				// ]w4ҦAm~ާ@
				QEI_INPUTS_NOSWAP & QEI_NORMAL_IO &				// Ow]}A`XJ
		     	QEI_INDEX_RESET_DISABLE & QEI_DIR_SEL_CNTRL ,	// Эm\AVܱ]w
			 	QEI_QE_CLK_DIVIDE_1_4 & QEI_QE_OUT_DISABLE ) ;
			 
}

void	uitoa( unsigned char *ASCII_Buf , unsigned int IntegerValue )
{
	
	unsigned int TempValue ;
	unsigned char ZeroDisable ;
	unsigned int  BaseQty ;
	unsigned int  Loop ;

	ZeroDisable = 1 ;
	BaseQty = 10000 ;

	for ( Loop = 0 ; Loop < 4 ; Loop ++)
	{
		TempValue = IntegerValue / BaseQty ;

			if 	( TempValue > 0) 	
				{
					*ASCII_Buf++ = (unsigned char)TempValue + '0' ;
					ZeroDisable = 0 ;
				}
			else if	( ZeroDisable == 0 ) 
					*ASCII_Buf++ = '0' ;
		IntegerValue = IntegerValue - ( TempValue * BaseQty ) ;
		BaseQty = BaseQty / 10 ;

	}
		*ASCII_Buf++ = (unsigned char)IntegerValue + '0' ;
		*ASCII_Buf = (unsigned char) 0x00 ;
		
}
